// Written by TeTeT
// sample mission for multiplayer radar script usage

// Basic idea is to have a subscriber pattern for radars
// there is a radar controller on the server
// the radar providers are pulled from the radar controller
// there are radar operators, on some clients
// a radar operator subscribes to the data from the radar controller
// the radar controller is global and holds different groups for probably different sides

if (isServer) then {
	private ["_nimspots", "_radarPos", "_radar", "_radars"];
	TTT_radarCtrl = "Land_HelipadEmpty_f" createVehicle [0,0,0];
	TTT_radarCtrl setVehicleVarName "RadarController";
	// Create Nimitz radar object
	_nimspots = ["nimspots"] call TTT_fnc_global;
	_radarPos = _nimspots modelToWorld (_nimspots selectionPosition "radar");

	/*_radar = "Sign_Arrow_Blue_F" createVehicle _radarPos;*/
	_radar = "Land_HelipadEmpty_f" createVehicle _radarPos;
	_radar setPosASL _radarPos;
	_radar setVehicleVarName "NimitzRadar";
	_radar setVariable ["TTT_radarLongRange", 10000, true];
	_radar setVariable ["TTT_radarShortRange", 4000, true];
	// LandRadar is defined in the mission for a change
	_radars = [_radar, LandRadar];
	TTT_radarCtrl setVariable ["TTT_radars", _radars, true];
	publicVariable "TTT_radarCtrl";
	[] execVM "functions\fn_radarServer.sqf";
};


private ["_marker", "_radar", "_radarPos", "_nimspots", "_radars"];

if (hasInterface) then {
	private ["_marker"];
	_marker = createMarkerLocal ["Nimitz", position Nimitz];
	_marker setMarkerTypeLocal "Nimitz";
	player addAction ["start radar",
		"[1, 10] execVM ""functions\fn_radar.sqf"";",
		nil,
		1,
		false,
		true,
		"",
		"isNil {player getVariable ""TTT_radar""}"
		];

	player addAction["stop radar",
		"player setVariable[""TTT_radar"", nil]",
		nil,
		1,
		false,
		true,
		"",
		"!isNil {player getVariable ""TTT_radar""}"
	];
};


if (isServer) then {

	// spawn some planes
	[] spawn {
		while {alive TTT_radarCtrl} do {
			private ["_veh", "_type", "_pos", "_altt", "_tgtPos", "_wp", "_dir"];
			_type = [ "JS_JC_FA18E", "JS_JC_FA18F", "FIR_F14D_VF111", "FIR_F14D_VF84", "B_Heli_Transport_03_F",
				  "O_Heli_Light_02_F", "O_Heli_Attack_02_F", "O_Heli_Transport_04_F", "O_Plane_CAS_02_F" ] call bis_fnc_selectRandom;
			_veh = _type createVehicle [0,0,1000];
			createVehicleCrew _veh;
			_altt = 500 + random 2000;

			_pos = Nimitz getPos [1000 + random 10000, random 360];
			_pos = [_pos select 0, _pos select 1, _altt];

			_veh setPosASL _pos;
			_dir = getDir _veh;
			// accelerate to roughly 200 km/h
			_veh setVelocity [sin _dir * 55, cos _dir * 55, 5];
			_veh flyInHeight _altt;

			_tgt = Nimitz getPos [random 1000, random 360];
			_wp = (group (crew _veh select 0)) addWaypoint [_tgt, 0];

			_tgt = Nimitz getPos [15000, random 360];
			_wp = (group (crew _veh select 0)) addWaypoint [_tgt, 0];

			[_veh, _tgt] spawn {
				params ["_veh", "_tgt"];
				waitUntil {_veh distance _tgt < 1000};
				{ deleteVehicle _x } forEach crew _veh;
				deleteVehicle _veh;
			};
			sleep 10;
		};
	};
};